package cds.aida.gui;
/* $Id: AboutDialog.java,v 1.1 2007/06/04 14:18:21 beugnot Exp $ */
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.KeyStroke;

/**
 * Just a dialog frame for credits/version/license/etc.
 */
public class AboutDialog {
	private Action actionDismiss; 
	// visu
	private JPanel p;
	private JFrame f;
	private JButton dismiss;
	
	/**
	 * Construct. and show() the frame
	 */
	public AboutDialog() {
		L10N lion=L10N.getInstance();
		actionDismiss=new ActionDismiss();
		
		p=new JPanel();
		String pname=(
				lion.get("main.name","Ada")+ //$NON-NLS-1$ //$NON-NLS-2$
				" v"+Conf.getInstance().get("version","0.1")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		p.setBorder(BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder(pname),
				BorderFactory.createEmptyBorder(5,10,10,10)));
		
		
		Box box=new Box(BoxLayout.Y_AXIS);
		box.add(new JLabel(
				lion.get("about.text"))); //$NON-NLS-1$
		box.add(new JSeparator());
		box.add(new JLabel(
				lion.get("about.owner","CDS")+" - "+ //$NON-NLS-1$ //$NON-NLS-2$
				lion.get("about.licence")), BorderLayout.SOUTH); //$NON-NLS-1$
		p.add(box);

		f=new JFrame(lion.get("about.label","About")); //$NON-NLS-1$ //$NON-NLS-2$
		Container fp=f.getContentPane();
		fp.setLayout(new BorderLayout());
		fp.add(p,BorderLayout.CENTER);
		dismiss=new JButton(actionDismiss);
		JPanel pdismiss=new JPanel();
		pdismiss.setBorder(BorderFactory.createEmptyBorder(10,30,10,30));
		pdismiss.add(dismiss);
		fp.add(pdismiss,BorderLayout.SOUTH);
		f.pack();
		f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}
	
	public JFrame getFrame() {
		return f;
	}
	
	public JPanel getPanel() {
		return p;
	}
	
	public void showFrame() {
		f.show();
	}
	
	class ActionDismiss extends AbstractAction {
		public ActionDismiss() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("about.dismiss","Close")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_C));
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ESC")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			f.dispose();
		}
	}
}
