package cds.aida.gui;
/* $Id: LookAndFeelActionListener.java,v 1.1 2007/06/04 14:18:21 beugnot Exp $ */
import java.awt.Component;
import java.awt.Cursor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.SwingUtilities;
import javax.swing.UIManager;

/**
 * Handling overall LnF changes
 * (using Cong.getInstance().getGraphicRoot() to revalidate)
 */
public class LookAndFeelActionListener implements ActionListener {
	private String classname;
	
	public LookAndFeelActionListener(String lnf_classname) {
		this.classname=lnf_classname;
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		Component c=Conf.getInstance().getGraphicRoot();
		try {
			c.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			UIManager.setLookAndFeel(classname);
			SwingUtilities.updateComponentTreeUI(c);
			c.validate();
			c.repaint();
			c.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR)); 
		}
		catch(Exception ex) {
			Logger.getInstance().log(Logger.TRACE,
					"LookAndFeelActionListerner.actionPerformed: "+ //$NON-NLS-1$
					"cannot setLnF("+classname+")"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		finally {
			if(c!=null) {
				c.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}
		}
	}
}
