package cds.aida.gui;
/* $Id: WorkSpace.java,v 1.1 2007/06/06 12:24:19 beugnot Exp $ */
import java.util.Observable;
import java.util.Observer;

import cds.aida.tool.Tool;

/**
 * Model for a generic workspace handling tool(s)
 * 
 * <p>rq: implements the "Observable" part,
 *  subclass must initObservable() in their const.
 */
public abstract class WorkSpace {
	protected ObservableWorkSpace ows;
	
	/**
	 * add a tool in the workspace
	 * @param t
	 */
	public abstract void addTool(Tool t);
	
	public void initObservable() {
		ows=new ObservableWorkSpace(this);
	}
	
	public void addObserver(Observer o) {
		ows.addObserver(o);
	}
	
	public void deleteObserver(Observer o) {
		ows.deleteObserver(o);
	}
	
	protected class ObservableWorkSpace extends Observable {
		private WorkSpace ws;
		public ObservableWorkSpace(WorkSpace ws) {
			this.ws=ws;
		}
		public void ping() {
			setChanged();
			notifyObservers(this);
		}
		// XXX iokdbg-wsping trying sthg
		public void ping(String msg) {
			setChanged();
			notifyObservers(msg);
		}
	}
}
