package cds.aida.tool;
/* $Id: Tool.java,v 1.4 2007/06/06 12:24:19 beugnot Exp $ */

import java.awt.Color;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.Serializable;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Observable;
import java.util.Observer;
import java.util.Vector;

import cds.aida.gui.Conf;
import cds.aida.gui.L10N;
import cds.aida.gui.Logger;
import cds.aida.w1.ToolCallStatus;
import cds.aida.wsJlow.WSJ;
import cds.jlow.client.descriptor.Attributs;
import cds.jlow.descriptor.Constant;
import cds.jlow.descriptor.IPortDescriptor;
import cds.jlow.descriptor.TaskDescriptor;
import cds.jlow.util.Type;
import cds.jlow.util.Utils;

/**
 * Model for a tool.
 * <p>provides tool description, i/o lists, call method, call status...
 * <p>rq: also a Jlow TaskDescriptor
 * @see ToolIO, DefaultToolView
 */
public class Tool extends TaskDescriptor
implements Transferable, Runnable{
	private String categorie;
	private String comment;

	
	//used for the workspace one tool
	public ObservableTool obs;
	private ToolCallStatus callStatus=ToolCallStatus.CALL_NOTCALLED;
	private String digest;
	private ToolPort stdout;
	private ToolPort stderr;
	/** inputs  */
//	private Vector i;
//	/** outputs */
//	private Vector o;
	
	
	DataFlavor[] flavors={
			DataFlavor.stringFlavor,
			new Tool.ToolDataFlavor()
	};
	

	
	public Tool(String id){
		super();
		obs=new ObservableTool(this);
		stdout=new ToolPort(id,L10N.getInstance().get("Tool.stdout.label"),L10N.getInstance().get("Tool.stdout.label"));
		stderr=new ToolPort(id,L10N.getInstance().get("Tool.stderr.label"),L10N.getInstance().get("Tool.stdout.label"));
		stdout.setData(new Constant());
		stderr.setData(new Constant());
//		i=new Vector();
//		o=new Vector();
		setIdOT(id);
	}
	
	public Tool(String id,String name){
		super();
		obs=new ObservableTool(this);
		stdout=new ToolPort(id,L10N.getInstance().get("Tool.stdout.label"),L10N.getInstance().get("Tool.stdout.label"));
		stderr=new ToolPort(id,L10N.getInstance().get("Tool.stderr.label"),L10N.getInstance().get("Tool.stdout.label"));
		stdout.setData(new Constant());
		stderr.setData(new Constant());
//		i=new Vector();
//		o=new Vector();
		setIdOT(id);
		setName(name);
	}
	
	public Tool(String id, String name, String comment){
		super();
		obs=new ObservableTool(this);
		setComment(comment);
		stdout=new ToolPort(id,L10N.getInstance().get("Tool.stdout.label"),L10N.getInstance().get("Tool.stdout.label"));
		stderr=new ToolPort(id,L10N.getInstance().get("Tool.stderr.label"),L10N.getInstance().get("Tool.stdout.label"));
		stdout.setData(new Constant());
		stderr.setData(new Constant());
//		i=new Vector();
//		o=new Vector();
		setIdOT(id);
		setName(name);
	}
	
	/**
	 * const. and basic settings
	 * @param id
	 * @param label
	 * @param comment
	 */
	public Tool(String id, String name, Hashtable mods, String comment) {
		super(id,name,mods);
		obs=new ObservableTool(this);
		setComment(comment);
		stdout=new ToolPort(id,L10N.getInstance().get("Tool.stdout.label"),L10N.getInstance().get("Tool.stdout.label"));
		stderr=new ToolPort(id,L10N.getInstance().get("Tool.stderr.label"),L10N.getInstance().get("Tool.stdout.label"));
		stdout.setData(new Constant());
		stderr.setData(new Constant());
//		i=new Vector();
//		o=new Vector();
		setIdOT(id);
		setName(name);
	}
	
	/**
	 * @return Returns the name of tool.
	 */
	public String toString(){
		return getName();
	}
		
	/**
	 * @return Returns the comment.
	 */
	public String getComment() {
		return comment;
	}
	/**
	 * @param comment The comment to set.
	 */
	public void setComment(String comment) {
		this.comment = comment;
	}
	
	public String getLabel(){
		return getName();
	}
	
	public void setLabel(String label) {
		if(label==null||label.equals("")) { //$NON-NLS-1$
			label=L10N.getInstance().get("tool.noname"); //$NON-NLS-1$
			label+="("+this.getIdOT()+")"; //$NON-NLS-1$ //$NON-NLS-2$
		}
		setName(label);
		// chg label in taskdescriptor ?
	}
	
	public Vector getListIPort(){
		return new Vector(this.getInputPort());
	}
	
//	public void setInputPort(Vector i2){
//		i=i2;
//	}
	
	public void setInputPort(String tpId){
		int portc = countInput();
		String tpmp;
//		String id = Utils.getIdUnique();
//		int miss=index-countInput();
//		while(miss>0) {
////			i.add(new ToolPort(id));
//			this.addInputPort(new ToolPort(id));
//			miss--;
//		}
//		tp.setIndex(index-1);
////		i.setElementAt(tp,index-1);
//		this.inputPort.set(index-1, tp);
		if(portc==0){
			this.addInputPort(tpId);
		}else{
			boolean newAdd=true;	
			do{
				portc--;
				tpmp = (String)inputPort.get(portc);
				if(tpmp.equals(tpId)){
					newAdd = false;
				}
			}while(portc>0);
			if(newAdd == true){
				this.addInputPort(tpId);
			}
		}
	}
	
	public Vector getListOPort(){
		return new Vector(outputPort);
	}
	
//	public void setOutputPort(Vector o2){
//		o=o2;
//	}
	
	public void setOutputPort(String tpId){
		int portc = countOutput();
		String tpmp;
//		String id = Utils.getIdUnique();
//		int miss=index-countOutput();
//		while(miss>0) {
////			o.add(tp);
//			this.addOutputPort(tp);
//			miss--;
//		}
//		tp.setIndex(index-1);
////		o.setElementAt(tp, index-1);
//		outputPort.set(index-1, tp);
		if(portc==0){
			this.addOutputPort(tpId);
		}else{
			boolean newAdd=true;	
			do{
				portc--;
				tpmp = (String)outputPort.get(portc);
				if(tpmp.equals(tpId)){
					newAdd = false;
				}
			}while(portc>0);
			if(newAdd == true){
				this.addOutputPort(tpId);
			}
		}
	}
	
	/**
	 * @param index
	 * @return output
	 */
	public Object getOutput(int index) {
		if(outputPort.size()<index) {
			return null;
		}
		return super.getOutputPort(index-1);
//		if(outputPort.size()<index) {
//			return null;
//		}
//		return (ToolPort)outputPort.get(index-1);
	}
	
	public Object getInput(int index) {
		if(inputPort.size()<index) {
			return null;
		}
		return  super.getInputPort(index-1);
//		if(i.size()<index) {
//			return null;
//		}
//		return (ToolPort)i.get(index-1);
	}
	


	
	protected boolean parseDescLineTool(String key[],String value) {
		Logger logger=Logger.getInstance();
		if(key[1].equals("label")) { //$NON-NLS-1$
			this.setName(value);
			//nom tache
		}
		else if(key[1].equals("comment")) { //$NON-NLS-1$
			this.setComment(value);;
		}
		else if(key[1].equals("categories")) { //$NON-NLS-1$
			//return parseDescLineCategories(value);
		}
		else if(key[1].equals("flags")) { //$NON-NLS-1$
			// XXX: setFlag
		}
		else {
			logger.log(
					Logger.WARNING,
					// XXX missing whole line to log properly
					"Tool.parseDescLine: tool key("+key[1]+") not handled"); //$NON-NLS-1$ //$NON-NLS-2$
			return false;
		}
		return true;
	}
	
	
	
	/**
	 * DataFlavor so that Tool is Transferable 
	 */
	public static class ToolDataFlavor extends DataFlavor {
		public ToolDataFlavor() {
			super(Tool.class, "Tool"); //$NON-NLS-1$
		}
	}
	
	public Object getTransferData(DataFlavor flavor) 
	throws UnsupportedFlavorException, IOException {
		if(flavor.equals(DataFlavor.stringFlavor)) {
			return this.getID();
		}
		else {
			return this;
		}
	}

	public DataFlavor[] getTransferDataFlavors() {
		// TODO Auto-generated method stub
		return flavors;
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		int j=flavors.length;
		for(int i=0;i<j;i++) {
			if(flavor.equals(flavors[i])) {
				return true;
			}
		}
		return false;
	}
	
	//This functions is used for the workspace one tool
	
	public ToolPort stdout() {
		return stdout;
	}
	public ToolPort stderr() {
		return stderr;
	}
	
	public int countInput() {
		return inputPort.size();
	}
	
	public int countOutput() {
		return outputPort.size();
	}
	
	public String encodeInputValue(String s) {
		String senc;
		try {
			senc=URLEncoder.encode(s,"utf-8"); //$NON-NLS-1$
		}
		catch(UnsupportedEncodingException uee) {
			// XXX try more ?
			senc=s;
		}
		return senc;
	}
	


	
	public void setDigest(String dgst){
		digest = dgst;
	}
	
	public String getDigest(){
		return digest;
	}
	

	
	public ToolCallStatus getCallStatus() {
		return callStatus;
	}
	public void setCallStatus(ToolCallStatus c) {
		Logger.getInstance().log(
				Logger.TRACE,
				"Tool.setCallStatus("+c+")"); //$NON-NLS-1$ //$NON-NLS-2$
		callStatus=c;
		obs.ping();
	}

	
	private String idToIdOp(String id) {
		Logger logger=Logger.getInstance();
		String gid=id;
		int idx=id.indexOf('.');
		if(idx==-1) {
//			logger.log(
//					Logger.WARNING,
//					"Tool.idToIdOp("+id+") has no dot suffix");
		}
		else {
			gid=id.substring(0,idx);
		}
		return gid;
	}
	/**
	 * Set tool ID
	 * @param id The id to set.
	 */
	public void setIdOT(String id) {
//		this.id=id;
		super.putAtt("idop",idToIdOp(id)); //$NON-NLS-1$
	}
	
	public String getIdOT() {
//		this.id=id;
		Object idop = getAtt("idop"); //$NON-NLS-1$
		if(idop!=null)
			return idop.toString();
		return null;
	}
	
	public class ObservableTool extends Observable implements Serializable {
		private Tool t;
		ObservableTool(Tool t) {
			this.t=t;
		}
		public void ping() {
			setChanged();
			notifyObservers(t);
		}
	}
	
	
	public ObservableTool getObs(){
		return obs;
	}
	
	public void run(){
		
	}
	
	public void addObserver(Observer o) {
		obs.addObserver(o);
	}
	public void deleteObserver(Observer o) {
		obs.deleteObserver(o);
	}
	
	public Object clone(){
		Tool desc = new Tool(this.getIdOT(), getName());
		desc.setID(Utils.getIdUnique());
//		desc.setOptable(new Hashtable(optable));
		desc.setAttable(new Hashtable(attable));
		desc.setModules(new Hashtable(modules));
		desc.setCallStatus(callStatus);
		desc.setComment(comment);		
		return desc;
	}
}
