package cds.aida.w1;
/* $Id: JDigitTextField.java,v 1.1 2007/06/06 12:24:19 beugnot Exp $ */

import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.DocumentFilter;
import javax.swing.text.PlainDocument;

import cds.aida.gui.Logger;

/**
 * JTextField which only accept digits inputs
 */
public class JDigitTextField extends JTextField {
	
	// XXX tested ?
	public JDigitTextField() {
		PlainDocument doc=new PlainDocument();
		DigitFilter filter=new DigitFilter();
		doc.setDocumentFilter(filter);
		this.setDocument(doc);
	}
	
	class DigitFilter extends DocumentFilter {
		public void insertString(
				FilterBypass fb,
				int offset,
				String string,
				AttributeSet attr)
		throws BadLocationException
		{
			String digitstr=""; //$NON-NLS-1$
			for(int i=0;i<string.length();i++) {
				char c=string.charAt(i);
				if(Character.isDigit(c)) {
					digitstr+=c;
				}
			}
			Logger.getInstance().log(
					Logger.TRACE,
					"JDigitTextField("+string+"->"+digitstr+")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if(!digitstr.equals("")) { //$NON-NLS-1$
				fb.insertString(offset, digitstr, attr);
			}
		}
	}
}
