package cds.aida.w1;
/* $Id: TextTransfer.java,v 1.1 2007/06/05 16:15:41 beugnot Exp $ */

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;

import cds.aida.gui.Logger;

/**
 * Text copy/paste with the system clipboard
 */
public class TextTransfer implements ClipboardOwner {
	
	public void lostOwnership(Clipboard clip, Transferable aContents) {
		// void
	}
	
	public void setClipboardContents(String s) {
		Logger.getInstance().log(
				Logger.TRACE,
				"TextTransfer.setClipboardContents("+s+")"); //$NON-NLS-1$ //$NON-NLS-2$
		StringSelection ss=new StringSelection(s);
		Clipboard clip=Toolkit.getDefaultToolkit().getSystemClipboard();
		clip.setContents(ss,this);
	}
	
	public String getClipboardContents() {
		Logger logger=Logger.getInstance();
		String s=""; //$NON-NLS-1$
		Clipboard clip=Toolkit.getDefaultToolkit().getSystemClipboard();
		Transferable contents=clip.getContents(null);
		if(contents==null) {
			logger.log(
					Logger.DEBUG,
					"TextTransfer.getClipboardContents(null)"); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
		if(!contents.isDataFlavorSupported(DataFlavor.stringFlavor)) {
			logger.log(
					Logger.DEBUG,
					"TextTransfer.getClipboardContents(!stringFlavor)"); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
		try {
			s=(String)contents.getTransferData(DataFlavor.stringFlavor);
		}
		catch(Exception ex) {
			logger.log(
					Logger.WARNING,
					"TextTransfer.getClipboardContent: "+ex.getMessage()); //$NON-NLS-1$
		}
		return s;
	}
} 
