package cds.aida.w1;
/* $Id: ToolIOViewBoolean.java,v 1.1 2007/04/23 10:10:24 beugnot Exp $ */

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JCheckBox;

import cds.aida.gui.L10N;
import cds.aida.gui.Logger;
import cds.aida.gui.ToolW1View;
import cds.aida.tool.ToolPort;
import cds.jlow.descriptor.IPortDescriptor;


/**
 */
public class ToolPortViewBoolean extends ToolW1View
implements Observer, ActionListener {

	JCheckBox field;
	
	public ToolPortViewBoolean(ToolPort io) {
		super(io);
		io.addObserver(this);
		field=new JCheckBox(
				L10N.getInstance().get(
				"boolean.label" //$NON-NLS-1$
				,"On/Off")); //$NON-NLS-1$
		reflectModelValue();
		field.addActionListener(this);
		if(io.getPosition()==IPortDescriptor.OUTPUT){
			field.setEnabled(false);
		}
		custom.add(field,BorderLayout.CENTER);
	}
	protected void reflectModelValue() {
		Enumeration e=io.getValues();
		Object o=io.getFirstValue();
		Logger.getInstance().log(
				Logger.TRACE,
				"ToolIOViewBoolean.val("+o+")"); //$NON-NLS-1$ //$NON-NLS-2$
		if((o!=null)&&(o.equals(true))) { //$NON-NLS-1$
			field.setSelected(true);
		}
		else {
			field.setSelected(false);
		}
	}
	public void update(Observable o, Object oo) {
		super.update(o,oo);
		reflectModelValue();
	}
	public void actionPerformed(ActionEvent e) {
		io.addValue(field.isSelected()?true:false); //$NON-NLS-1$ //$NON-NLS-2$
	}
	public Dimension getDefaultDimension() {
		Dimension d=new Dimension();
		L10N lion=L10N.getInstance();
		int x=lion.getInt("tool.io.type.bool.x",new Integer(142)); //$NON-NLS-1$
		int y=lion.getInt("tool.io.type.bool.y",new Integer(142)); //$NON-NLS-1$
		d.setSize(x,y);
		return d;
	}
}
