package cds.aida.w1;
/* $Id: ToolPortViewFiles.java,v 1.2 2007/06/06 12:24:19 beugnot Exp $ */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.net.UnknownHostException;
import java.util.Enumeration;
import java.util.Observable;
import java.util.Observer;

import javax.swing.AbstractAction;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRootPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import cds.aida.gui.Conf;
import cds.aida.gui.L10N;
import cds.aida.gui.Logger;
import cds.aida.gui.ToolW1View;
import cds.aida.tool.ToolPort;
import cds.jlow.descriptor.IPortDescriptor;




/**
 */
public class ToolPortViewFiles extends ToolW1View
implements Observer, KeyListener, ActionListener {
	ToolPort iof;
	JPanel p;
	JTextField input;
	JList list;
	DefaultListModel listmodel;
	String bwsInitDir = "";
	
	AddFile af=new AddFile();
	browseFile bf = new browseFile();
	ClearFiles cf=new ClearFiles(ClearFiles.ALL_FILES);
	ClearFiles csf=new ClearFiles(ClearFiles.SELECTED_FILES);
	//ExtViewer extv1=new ExtViewer();
	
	JButton add;
	JButton browse;
	JButton clr;
	JButton extview;
	
	public ToolPortViewFiles(ToolPort io) {
		super(io);
		try {
			iof=io;
		}
		catch(ClassCastException cce) {
			Logger.getInstance().log(
					Logger.WARNING,
					"ToolIOViewFiles.keyReleased: Should be a ToolIOFiles"); //$NON-NLS-1$
		}
		boolean isInput;
		if(io.getPosition()==IPortDescriptor.INPUT){
			isInput=true;
		}else{
			isInput=false;
		}
		io.addObserver(this);
		
		p=new JPanel();
		p.setLayout(new BorderLayout());
		if(isInput) {
			// input field
			Object def=io.getDefaultValue();
			input=new JTextField((def==null)?"":def.toString()); //$NON-NLS-1$
			input.addKeyListener(this);
			
			// add/clear buttons panel
			JPanel ipb=new JPanel();
			ipb.setLayout(new FlowLayout());
			add=new JButton(af);
			browse = new JButton("Browse");
			clr=new JButton(cf);
			ipb.add(add);
			ipb.add(browse);
			ipb.add(clr);
			browse.addActionListener(this);

			// input/buttons composition
			JPanel ip=new JPanel();
			ip.setLayout(new BorderLayout());
			ip.add(input,BorderLayout.CENTER);
			ip.add(ipb, BorderLayout.EAST);
			
			p.add(ip,BorderLayout.NORTH);
		}
		else {
			// if ready, files might be viewed
			JPanel opb=new JPanel();
			opb.setLayout(new FlowLayout());
			//extview=new JButton(extv1);
		}
		
		// list representing the model
		// XXX ToolIOFiles should have impl. ListModel, wld have been better
		listmodel=new DefaultListModel();
		list=new JList(listmodel);
		list.addKeyListener(this);
		list.addMouseListener(new FilesMouseListener());
		list.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
		reflectModelValues();
		p.add(list, BorderLayout.CENTER);
		
		if(!isInput) {
			list.setBackground(Color.LIGHT_GRAY);
		}
		this.add(p,BorderLayout.CENTER);
	}
	
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		bf.perform();
	}
	
	
	/**
	 * Reconstructs files list according to the ToolIOFiles content.
	 */
	protected void reflectModelValues() {
		Logger logger=Logger.getInstance();
		logger.log(
				Logger.TRACE,
				"ToolIOViewFiles.reflectModelValues"); //$NON-NLS-1$
		Enumeration e=io.getValues();
		listmodel.removeAllElements();
		int i=1;
		while(e.hasMoreElements()) {
			String val=e.nextElement().toString();
			logger.log(
					Logger.TRACE,
					"ToolIOViewFiles.io.getValue("+(i++)+"="+val+")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			listmodel.addElement(val);
		}
		if(i==1&&input!=null) {
			// no values, we'd better clean input field too
			input.setText("");			 //$NON-NLS-1$
		}
	}
	public void update(Observable o, Object oo) {
		super.update(o,oo);
		reflectModelValues();
	}
	
	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {
		// in input field, "return" adds value.
		if(e.getKeyCode()==KeyEvent.VK_ENTER) {
			af.perform();
		}
		// in values list, "delete" removes selected values
		else if(e.getKeyCode()==KeyEvent.VK_DELETE) {
			csf.perform();
		}
	}
	public Dimension getDefaultDimension() {
		Dimension d=new Dimension();
		L10N lion=L10N.getInstance();
		int x=lion.getInt("tool.io.type.files.x",new Integer(642)); //$NON-NLS-1$
		int y=lion.getInt("tool.io.type.files.y",new Integer(442)); //$NON-NLS-1$
		d.setSize(x,y);
		return d;
	}


	private class ExtViewer extends AbstractAction {
		ExtViewer() {
			L10N lion=L10N.getInstance();
			putValue(NAME, lion.get("tool.iofiles.extview","View")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		public void actionPerformed(ActionEvent e) {
			perform();
		}
		public void perform() {
			
		}
	}
	private class AddFile extends AbstractAction {
		AddFile() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("tool.iofiles.add","Add")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		public void actionPerformed(ActionEvent e) {
			perform();
		}
		public void perform() {
			String s=input.getText();
			if(!s.equals("")) { //$NON-NLS-1$
				s.trim();
				io.addValue(s);
			}
		}
	}
	
	public class browseFile extends AbstractAction {
		public browseFile() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("tool.iofiles.add","Add")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		public void actionPerformed(ActionEvent e) {
			perform();
		}
		public void perform() {
			String s;
			Explore ep = new Explore();
			File file;
			if(bwsInitDir.equals("")){
				file = ep.init();
			}else{
				file = ep.init(bwsInitDir);
			}
			
			if(file!=null){
				String filestr = file.getAbsolutePath();
				bwsInitDir = file.getParentFile().toString();
				AddFile af = new AddFile();
				input.setText(filestr);
				af.perform();
			}
			
			
			/*if(!s.equals("")) { //$NON-NLS-1$
				s.trim();
				io.addValue(s);
			}*/
		}
		public void setio(String s){
			io.addValue(s);
		}
	}
	
	private class SaveFiles extends AbstractAction {
		public static final int ALL_FILES=1;
		public static final int SELECTED_FILES=2;
		private int type;
		/**
		 * default: save ALL_FILES
		 */
		SaveFiles() {
			this(ALL_FILES);
		}
		SaveFiles(int type) {
			this.type=type;
			switch(type) {
			case SELECTED_FILES:
				setSaveSelectedFiles();
				break;
			case ALL_FILES: // fallthru
			default:
				setSaveAllFiles();
			}
		}
		void setSaveAllFiles() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get(
					"tool.iofiles.saveall" //$NON-NLS-1$
					,"Save all files")); //$NON-NLS-1$
		}
		void setSaveSelectedFiles() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get(
					"tool.iofiles.saveselected" //$NON-NLS-1$
					,"Save selected files"));		 //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			perform();
		}
		public void perform() {
			// XXX separate dialog and action
			// XXX and save progress bar (in tab ?)
			JDirectoryChooser jfc=new JDirectoryChooser();
			int ret=jfc.showDialog(getParent(),null);
			if(ret==JFileChooser.APPROVE_OPTION) {
				File dir=jfc.getSelectedFile();
				Logger.getInstance().log(
						Logger.TRACE,
						"ToolIOViewFiles.SaveFiles: dir("+dir+")"); //$NON-NLS-1$ //$NON-NLS-2$

				switch(type) {
				case SELECTED_FILES:
					performSaveSelected(dir.toString(),jfc.getPrefix());
					break;
				case ALL_FILES:
				default:
					performSaveAll(dir.toString(),jfc.getPrefix());
				}
				
			}
		}
		void performSaveAll(String target_dir) {
			performSaveAll(target_dir,""); //$NON-NLS-1$
		}
		void performSaveAll(String target_dir,String prefix) {
			try {
				Enumeration e=iof.getValues();
				while(e.hasMoreElements()) {
					Object o=e.nextElement();
					String f=o.toString();
					// XXX if we cant save there, will produce as many
					// errors as there are files to save. Not good.
					performSave(f,target_dir,prefix);
				}
			}
			catch(Exception ex) {
				Logger.getInstance().log(
						Logger.ERROR,
						"ToolIOViewFiles.SaveFiles: "+ex.getMessage()); //$NON-NLS-1$
			}
		}
		void performSaveSelected(String target_dir) {
			performSaveSelected(target_dir,""); //$NON-NLS-1$
		}
		void performSaveSelected(String target_dir,String prefix) {
			int idx[]=list.getSelectedIndices();
			for(int i=0;i<idx.length;i++) {
				int x=idx[i];
				Object o=listmodel.elementAt(x);
				String f=o.toString();
				performSave(f,target_dir,prefix);
			}
		}
		
		/**
		 * @param file - URL
		 * @param target_dir
		 */
		void performSave(String file, String target_dir) {
			performSave(file,target_dir,""); //$NON-NLS-1$
		}
		/**
		 * @param file - URL
		 * @param target_dir
		 * @param target_name (if blank, will extract target name from file)
		 */
		boolean performSave(String file, String target_dir, String prefix) {
			String target=prefix+extractName(file);
			Logger logger=Logger.getInstance();
			logger.log(
					Logger.TRACE,
					"ToolIOViewFiles.SaveFiles.performSave("+file+")"); //$NON-NLS-1$ //$NON-NLS-2$

			// check target directory
			File td=new File(target_dir);
			if(!td.isDirectory()) {
				cannotSave(target_dir,"notdir"); //$NON-NLS-1$
				return false;
			}
			if(!td.canWrite()) {
				cannotSave(target_dir,"notwritable"); //$NON-NLS-1$
				return false;
			}
			// check if source seems to be an url
			// XXX regexp
			if(!file.toLowerCase().startsWith("http://")&& //$NON-NLS-1$
					!file.toLowerCase().startsWith("ftp://")) { //$NON-NLS-1$
				cannotSave(file,"noturl"); //$NON-NLS-1$
				return false;
			}
			// check target file and overwriting 
			String fn=target_dir+File.separator+target;
			File outf=new File(fn);
			if(outf.exists()) {
				String ask=L10N.getInstance().get(
						"tool.iofiles.askoverwrite","Overwrite?"); //$NON-NLS-1$ //$NON-NLS-2$
				int ov=JOptionPane.showConfirmDialog(getParent(),ask);
				if(ov!=JOptionPane.YES_OPTION) {
					logger.log(
							Logger.INFO,
							"ToolIOViewFiles.cancelOverwrite("+file+")"); //$NON-NLS-1$ //$NON-NLS-2$
					return false;
				}
			}
//			if(!outf.canWrite()) {
//				cannotSave(fn,"notwritable");
//				return false;
//			}
			
			int count=0; // number of bytes
			try {
				// XXX threaded saving and popup 'saving...'
				// rq: cannot know data size, so no progress bar
				URL url;
				URLConnection urlc;
				url=new URL(file);
				urlc=url.openConnection();
				urlc.setUseCaches(false);
				urlc.setRequestProperty(
						"User-Agent", //$NON-NLS-1$
						Conf.getInstance().getUserAgent());
				InputStream is=urlc.getInputStream();
				FileOutputStream fout=new FileOutputStream(outf);
				int raw=0;
				while((raw=is.read())!=-1) {
					fout.write(raw);
					count++;
				}
			}
			catch(UnknownHostException uhe) {
				cannotSave(uhe.getMessage(),"unknownhost"); //$NON-NLS-1$
				return false;
			}
			catch(FileNotFoundException fnfe) {
				cannotSave(fnfe.getMessage(),"filenotfound"); //$NON-NLS-1$
				return false;
			}
			catch(Exception ex) {
				cannotSave(ex.getMessage(),"failed"); //$NON-NLS-1$
				return false;
			}
			logger.log(
					Logger.INFO,
					"ToolIOViewFiles.SaveFiles.performSave: "+ //$NON-NLS-1$
					"saved("+file+")as("+fn+")for("+count+")bytes"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			return true;
		}
		
		// 'msg': lion.get("tool.iofiles.saverr."+err)
		private void cannotSave(String msg, String err) {
			Logger logger=Logger.getInstance();
			L10N lion=L10N.getInstance();
			String lionerr=lion.get("tool.iofiles.saverr."+err); //$NON-NLS-1$
			logger.log(
					Logger.WARNING,
					"ToolIOViewFiles.cannotSave: '"+msg+"': "+lionerr); //$NON-NLS-1$ //$NON-NLS-2$
			JOptionPane.showMessageDialog(
					getParent(),
					"'"+msg+"':\n"+lionerr, //$NON-NLS-1$ //$NON-NLS-2$
					lion.get("tool.iofiles.saverr.title"), //$NON-NLS-1$
					JOptionPane.ERROR_MESSAGE
					);
		}
		/**
		 * @param file - URL or ?
		 * @return filename to save to
		 */
		private String extractName(String file) {
			int sep=File.separatorChar;
			int idx=file.lastIndexOf(sep);
			String name=file;
			if(idx!=-1) {
				name=file.substring(idx+1);
			}
			Logger.getInstance().log(
					Logger.TRACE,
					"ToolIOViewFiles.SaveFiles.extractName("+file+"="+name+")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return name;
		}
	}
	private class CopyFileName extends AbstractAction {
		CopyFileName() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get(
					"tool.iofiles.copyfilename", //$NON-NLS-1$
					"Copy file name")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			perform();
		}
		public void perform() {
			try {
				int idx=list.getSelectedIndex();
				if(idx!=-1) {
					String f=listmodel.get(idx).toString();
					TextTransfer tt=new TextTransfer();
					tt.setClipboardContents(f);
				}
				else {
					Logger.getInstance().log(
							Logger.INFO,
							"ToolIOViewFiles.CopyFileName.perform: "+ //$NON-NLS-1$
							"no selected files"); //$NON-NLS-1$
				}
			}
			catch(Exception ex) {
				Logger.getInstance().log(
						Logger.DEBUG,
						"ToolIOViewFiles.CopyFileName.perform: "+ //$NON-NLS-1$
						ex.getMessage());
				ex.printStackTrace();
			}
		}
	}
	private class OpenFileInTab extends AbstractAction {
		OpenFileInTab() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get(
					"tool.iofiles.openfileintab", //$NON-NLS-1$
					"Open file in tab")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			perform();
		}
		public void perform() {
			// TODO open
		}
	}
	private class ClearFiles extends AbstractAction {
		public static final int ALL_FILES=1;
		public static final int SELECTED_FILES=2;
		private int type;
		ClearFiles() {
			this(ALL_FILES);
		}
		ClearFiles(int type) {
			this.type=type;
			switch(type) {
			case SELECTED_FILES:
				setClearSelectedFiles();
				break;
			case ALL_FILES:
			default:
				setClearAllFiles();
			}
		}
		void setClearAllFiles() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("tool.iofiles.clear","Clear")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		void setClearSelectedFiles() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get(
					"tool.iofiles.clearselected" //$NON-NLS-1$
					,"Remove selected files")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			perform();
		}
		public void perform() {
			switch(type) {
			case SELECTED_FILES:
				int idx[]=list.getSelectedIndices();
				iof.removeValuesAt(idx);
				break;
			case ALL_FILES:
			default:
				io.clearValues();
			}
		}
	}
	private class FilesMouseListener extends MouseAdapter {
		JPopupMenu pop_in, pop_out;
		JMenuItem menu_clr, menu_csf;
		FilesMouseListener() {
			super();
			pop_in=new JPopupMenu();
			pop_out=new JPopupMenu();
			menu_clr=new JMenuItem(cf);
			menu_csf=new JMenuItem(csf);
			
			JMenuItem saveselected=new JMenuItem(
					new SaveFiles(
							SaveFiles.SELECTED_FILES));
			JMenuItem saveall=new JMenuItem(
					new SaveFiles(
							SaveFiles.ALL_FILES));
			JMenuItem copyfn=new JMenuItem(new CopyFileName());
			JMenuItem openintab=new JMenuItem(new OpenFileInTab());
			pop_out.add(saveselected);
			pop_out.add(saveall);
			pop_out.add(copyfn);
			pop_out.add(openintab);

			JMenuItem saveselected2=new JMenuItem(
					new SaveFiles(
							SaveFiles.SELECTED_FILES));
			JMenuItem saveall2=new JMenuItem(
					new SaveFiles(
							SaveFiles.ALL_FILES));
			pop_in.add(menu_clr);
			pop_in.add(menu_csf);
			pop_in.add(saveselected2);
			pop_in.add(saveall2);
		}
		public void mouseClicked(MouseEvent e) {
//			if(io.isInput()) {
//			}
//			else {
				if(e.getClickCount()==2) {
					int idx=list.locationToIndex(e.getPoint());
					String s=iof.valueAt(idx);
					// XXX dbl clk default action ?
					CopyFileName cfn=new CopyFileName();
					list.setSelectedIndex(idx);
					cfn.perform();
					
					// XXX temp. select. dialog
					Point p=list.getLocationOnScreen();
					p.translate(e.getX(),e.getY());
					SingleFileViewer sfv=new SingleFileViewer(s,p);
					sfv.setVisible(true);
					
					
//					JOptionPane.showMessageDialog(
//							e.getComponent(),
//							"File("+s+")",
//							"",
//							JOptionPane.INFORMATION_MESSAGE
//					);
				}
//			}
		}
		public void mousePressed(MouseEvent e) {
			mayPopup(e);
		}
		public void mouseReleased(MouseEvent e) {
			mayPopup(e);
		}
		protected void mayPopup(MouseEvent e) {
			if(e.isPopupTrigger()) {
				Component c=e.getComponent();
				int x=e.getX();
				int y=e.getY();
				if(io.getPosition()==IPortDescriptor.INPUT) {
					pop_in.show(c,x,y);
				}
				else {
					pop_out.show(c,x,y);
				}
			}
		}
	}
	class SingleFileViewer extends JFrame {
		JPanel pan, bar, disp;
		JTextField txt;
		JButton view, close;
		String file;
		
		SingleFileViewer(String s) {
			this(s,null);
		}
		SingleFileViewer(String s, Point p) {
			setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			file=s;
			
			pan=new JPanel();
			pan.setLayout(new BorderLayout());
			bar=new JPanel();
			bar.setLayout(new FlowLayout());
			view=new JButton(new ActionView());
			close=new JButton(L10N.getInstance().get("menu.close","Close"));
			close.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					dispose();
				}
			});
			disp=new JPanel();
			txt=new JTextField(s);
			txt.setEditable(false);
			
			bar.add(txt);
			bar.add(view);
			bar.add(close);
			pan.add(bar, BorderLayout.NORTH);

			JRootPane jpr=getRootPane();
			jpr.setContentPane(pan);
			if(p!=null) {
				setLocation(p);
			}
			pack();
		}
		private class ActionView extends AbstractAction {
			ActionView() {
				L10N lion=L10N.getInstance();
				putValue(NAME,
						lion.get(
								"tool.iofiles.view", //$NON-NLS-1$
								"View")); //$NON-NLS-1$
			}
			public void actionPerformed(ActionEvent e) {
				perform();
			}
			public void perform() {
				// TODO async
				try {
					URL u=new URL(file);
					HttpURLConnection huc=(HttpURLConnection)u.openConnection();
					huc.setRequestMethod("GET");
					huc.setRequestProperty(
							"User-Agent",
							Conf.getInstance().getUserAgent()); //$NON-NLS-1$
					String type=huc.getContentType();

					String expect=iof.toString();
					
					// TODO: boo, ugly temporary handling of mime types:
					if(  "image/jpeg".equals(type)
						||"image/jpg".equals(type)
						||"image/png".equals(type)
						||"image/gif".equals(type)) {
						ImageIcon ii=new ImageIcon(u);
						ScrollablePicture sp=new ScrollablePicture(ii,10);
						JScrollPane jsp=new JScrollPane(sp);
						pan.add(jsp,BorderLayout.CENTER);
						pack();
						repaint();
					}
					else if("text/plain".equals(type)
							||"text/html".equals(type)) {
						Object content=huc.getContent();
						JTextArea jta=new JTextArea();
						jta.setText(content.toString());
//						System.out.println(
//								"IOKDBG: TIOVF.SFV: "+
//								content.toString().substring(0,42)+"...");
						JScrollPane jsp=new JScrollPane(jta);
						pan.add(jsp,BorderLayout.CENTER);
						revalidate();
						pack();
						repaint();
					}
					else {
						JOptionPane.showMessageDialog(
								view,
								"Don't know how to display content("+type+")"+
								"\nof URL("+file+")",
								"Error viewing URL",
								JOptionPane.ERROR_MESSAGE);
					}
				}
				catch(Exception e) {
					JOptionPane.showMessageDialog(
							view,
							"Cannot view the URL("+file+")",
							"Error viewing URL",
							JOptionPane.ERROR_MESSAGE);
					e.printStackTrace();
				}
			}
		}
	}
	class JDirectoryChooser extends JFileChooser {
		JTextField prefix=new JTextField(""); //$NON-NLS-1$
		JDirectoryChooser() {
			L10N lion=L10N.getInstance();
			String approve=lion.get(
					"tool.iofiles.selectdir" //$NON-NLS-1$
					,"Select directory"); //$NON-NLS-1$
			setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			setDialogType(JFileChooser.CUSTOM_DIALOG);
			setApproveButtonText(approve);
			setDialogTitle(approve);
			setMultiSelectionEnabled(false);
			setAcceptAllFileFilterUsed(false);
			setDialogType(SAVE_DIALOG);
			addPrefixChooser();
		}
		public void addPrefixChooser() {
			JPanel p=new JPanel();
			p.setLayout(new BorderLayout());
			Box q=new Box(BoxLayout.Y_AXIS);
			q.setBorder(new EmptyBorder(10,10,10,10)); // XXX hc
			String plabel=L10N.getInstance().get(
					"tool.iofiles.prefix.label", //$NON-NLS-1$
					"Prefix"); //$NON-NLS-1$
			q.add(new JLabel(plabel)); // XXX label
			q.add(prefix);
			p.add(q,BorderLayout.NORTH);
			p.setPreferredSize(
					new Dimension(
							(int)(0.8*this.getPreferredSize().getWidth()),
							42 //XXX hc
					)
			);
//			Logger.getInstance().log(
//					Logger.DEBUG,
//					"ToolIOViewFiles.JDirectoryChooser.addPrefixChooser:size("+
//					(int)(0.8*this.getPreferredSize().getWidth())+","+
//					p.getHeight()+")");
			setAccessory(p);
		}
		public String getPrefix() { return prefix.getText(); }
		public void setPrefix(String p) { prefix.setText((p==null)?"":p); } //$NON-NLS-1$
	}

}
