package cds.aida.w1;
/* $Id: ToolPortViewString.java,v 1.2 2007/06/06 12:24:19 beugnot Exp $ */

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Enumeration;
import java.util.Observable;
import java.util.Observer;

import javax.swing.AbstractAction;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JTextField;

import cds.aida.gui.L10N;
import cds.aida.gui.ToolW1View;
import cds.aida.tool.ToolPort;
import cds.jlow.descriptor.IPortDescriptor;


/**
 */
public class ToolPortViewString extends ToolW1View
implements  KeyListener,Observer {

	Box ui;
	JTextField field;
	JButton def;
	JButton clr;
	String tmpField="";
	
	public ToolPortViewString(ToolPort io) {
		super(io);
		io.addObserver(this);
		ui=new Box(BoxLayout.X_AXIS);
		field=new JTextField();
		def=new JButton(new ActionDefaultValue());
		clr = new JButton(new ActionClear());
		
		field.addKeyListener(this);
		if(io.getPosition() != IPortDescriptor.INPUT) {
			field.setEditable(false);
		}
		// add field before reflectMV, so that def button always to the right

		reflectModelValue();
		Object o=io.getDefaultValue();
		if(o!=null) {
			io.clearValues();
			io.addValue(o.toString());
		}
		custom.add(ui,BorderLayout.CENTER);
	}
	protected void reflectModelValue() {
		Enumeration e=io.getValues();
		if((e!=null)&&e.hasMoreElements()) {
			String text=e.nextElement().toString();
			System.out.println(text);
			// if(!field.getText().equals(text)) {
			field.setText(text);
			tmpField=text;
			// }
		}
		else {
			field.setText(""); //$NON-NLS-1$
		}

		ui.add(field);
		ui.remove(def);
		
		Object o=io.getDefaultValue();
		if(o!=null) {
			ui.add(def);
		}
		ui.add(clr);
	}
	public void update(Observable o, Object oo) {
		super.update(o,oo);
		reflectModelValue();
	}
	public void keyReleased(KeyEvent e) {
		io.addValue(field.getText());
	}
	public void keyPressed(KeyEvent e) {
		
	}
	public void keyTyped(KeyEvent e) {
	}
	class ActionDefaultValue extends AbstractAction {
		ActionDefaultValue() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("tool.iodefault.label","Default Value")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		public void actionPerformed(ActionEvent e) {
			Object o=io.getDefaultValue();
			if(o!=null) {
				io.clearValues();
				io.addValue(o.toString());
			}
		}
	}
	
	class ActionClear extends AbstractAction {
		ActionClear() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("tool.iofiles.clear","Clear")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		public void actionPerformed(ActionEvent e) {
			io.clearValues();
		}
	}
	
	public Dimension getDefaultDimension() {
		Dimension d=new Dimension();
		L10N lion=L10N.getInstance();
		int x=lion.getInt("tool.io.type.string.x",new Integer(442)); //$NON-NLS-1$
		int y=lion.getInt("tool.io.type.string.y",new Integer(142)); //$NON-NLS-1$
		d.setSize(x,y);
		return d;
	}
}
