package cds.aida.w1;

import cds.aida.gui.Logger;
/* $Id: ToolViewFactory.java,v 1.1 2007/06/04 14:18:21 beugnot Exp $ */
import cds.aida.tool.Tool;
import cds.jlow.client.graph.Jlow;
import cds.jlow.descriptor.Register;

/**
 * Create appropriate ToolView for given Tool
 */
public class ToolViewFactory {
	public static final int AIDA=1;
	public static final int DEFAULT=0;
	private static final int DEFAULT_TYPE= AIDA; 

	public static ToolView create(Tool t,Register reg) {
		return ToolViewFactory.create(DEFAULT,t,reg);
	}
	public static ToolView create(int type, Tool t,Register reg) {
		ToolView tv=null;
		switch(type) {
			case DEFAULT:
				tv=ToolViewFactory.create(DEFAULT_TYPE,t,reg);
				break;
			case AIDA:
				tv=new DefaultToolView(t,reg);
				break;
			default:
				Logger.getInstance().log(
						Logger.WARNING,
						"Unknown type("+type+") of toolview. "+ //$NON-NLS-1$ //$NON-NLS-2$
						"Creating default toolview" //$NON-NLS-1$
						);
				tv=ToolViewFactory.create(DEFAULT_TYPE,t,reg);
		}
		return tv;
	}
}
