package cds.aida.wsJlow;

import cds.aida.gui.Logger;
/* $Id: ToolViewFactory.java,v 1.1 2007/06/04 14:18:21 beugnot Exp $ */
import cds.aida.tool.Tool;
import cds.jlow.client.graph.Jlow;
import cds.jlow.descriptor.Register;

/**
 * Create appropriate ToolView for given Tool
 */
public class ToolViewFactoryWS {
	public static final int AIDA=1;
	public static final int DEFAULT=0;
	private static final int DEFAULT_TYPE= AIDA; 

	public static ToolViewWS create(Tool t,Jlow g) {
		return ToolViewFactoryWS.create(DEFAULT,t,g);
	}
	public static ToolViewWS create(int type, Tool t,Jlow g) {
		ToolViewWS tv=null;
		switch(type) {
			case DEFAULT:
				tv=ToolViewFactoryWS.create(DEFAULT_TYPE,t,g);
				break;
			case AIDA:
				tv=new DefaultTPView(t,g);
				break;
			default:
				Logger.getInstance().log(
						Logger.WARNING,
						"Unknown type("+type+") of toolview. "+ //$NON-NLS-1$ //$NON-NLS-2$
						"Creating default toolview" //$NON-NLS-1$
						);
				tv=ToolViewFactoryWS.create(DEFAULT_TYPE,t,g);
		}
		return tv;
	}
}
