//
//------
//
//JLOW - Java Libraries fOr Workflow
//
//Author:  Cyril Pestel
//Address: Centre de Donnees astronomiques de Strasbourg
//11 rue de l'Universite
//67000 STRASBOURG
//FRANCE
//Email:   schaaff@astro.u-strasbg.fr, question@simbad.u-strasbg.fr
//
//-------
//
//In accordance with the international conventions about intellectual
//property rights this software and associated documentation files
//(the "Software") is protected. The rightholder authorizes :
//the reproduction and representation as a private copy or for educational
//and research purposes outside any lucrative use,
//subject to the following conditions:
//
//The above copyright notice shall be included.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
//OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, NON INFRINGEMENT,
//LOSS OF DATA, LOSS OF PROFIT, LOSS OF BARGAIN OR IMPOSSIBILITY
//TO USE SUCH SOFWARE. IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE
//FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
//TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
//THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//For any other exploitation contact the rightholder.
//
//-----------
//
//Conformement aux conventions internationales relatives aux droits de
//propriete intellectuelle ce logiciel et sa documentation sont proteges.
//Le titulaire des droits autorise :
//la reproduction et la representation a titre de copie privee ou des fins
//d'enseignement et de recherche et en dehors de toute utilisation lucrative.
//Cette autorisation est faite sous les conditions suivantes :
//
//La mention du copyright portee ci-dessus devra etre clairement indiquee.
//
//LE LOGICIEL EST LIVRE "EN L'ETAT", SANS GARANTIE D'AUCUNE SORTE.
//LE TITULAIRE DES DROITS NE SAURAIT, EN AUCUN CAS ETRE TENU CONTRACTUELLEMENT
//OU DELICTUELLEMENT POUR RESPONSABLE DES DOMMAGES DIRECTS OU INDIRECTS
//(Y COMPRIS ET A TITRE PUREMENT ILLUSTRATIF ET NON LIMITATIF,
//LA PRIVATION DE JOUISSANCE DU LOGICIEL, LA PERTE DE DONNEES,
//LE MANQUE A GAGNER OU AUGMENTATION DE COUTS ET DEPENSES, LES PERTES
//D'EXPLOITATION,LES PERTES DE MARCHES OU TOUTES ACTIONS EN CONTREFACON)
//POUVANT RESULTER DE L'UTILISATION, DE LA MAUVAISE UTILISATION
//OU DE L'IMPOSSIBILITE D'UTILISER LE LOGICIEL, ALORS MEME
//QU'IL AURAIT ETE AVISE DE LA POSSIBILITE DE SURVENANCE DE TELS DOMMAGES.
//
//Pour toute autre utilisation contactez le titulaire des droits.
//

package cds.aida.gui;

//import java.awt.Color;
//import java.util.*;
import java.awt.Color;

import javax.swing.JOptionPane;

import cds.jlow.client.graph.event.*;
import cds.jlow.client.descriptor.*;
import cds.jlow.client.graph.*;
import cds.jlow.client.util.ToStringModule;
import cds.jlow.descriptor.IDataDescriptor;
import cds.jlow.descriptor.IDescriptor;
import cds.jlow.descriptor.IPortDescriptor;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.util.Module;
import cds.jlow.util.Module;

import org.jgraph.graph.*;

/**
 * A listener for the descriptors from the graph. This listener notify when the
 * data is empty (null value).
 * 
 * @author Cyril Pestel
 * @version 1.0 beta Copyright CDS 2005 (kickoff 1 April 05)
 */
public class CustomGDListener implements GraphDescriptorListener {

	/**
	 * Creates a listener for the descrptors from the graph.
	 */
	public CustomGDListener() {

	}

	/**
	 * Invoked when a IDescriptor into the graph has changed.
	 * 
	 * Puts the the Data flag at NORECEIVE if data is not null and changes the
	 * color of the edge.
	 * 
	 * @param event
	 *            an GraphDescriptorEvent
	 */
	public void graphChanged(GraphDescriptorEvent event) {
		IDescriptor desc = (IDescriptor) event.getSource();
		Jlow graph = event.getGraph();

		DefaultGraphCell cell = Jlow.getCellForDescriptor(graph, desc);

		if (desc != null) {
			
			//** PORT **\\
			if (desc instanceof IPortDescriptor) {
				//System.out.println("PortDescriptor modified " + desc);

				Object key = graph.getJlowmodel().getModelindex(desc);
				Attributs atts = graph.getJlowmodel().getAttributs(key);

				Color col = atts.getBGColor();

				if (((IPortDescriptor) desc).getData().getData() != null) {
					if (cell != null) {
						
						blink(graph, cell, col.brighter(), col);
					}
				}
			}
			
			//** TASK **\\
			if (desc instanceof ITaskDescriptor) {
				//System.out.println("TaskDescriptor modified");
				
				Object key = graph.getJlowmodel().getModelindex(desc);
				Attributs atts = graph.getJlowmodel().getAttributs(key);

				Color col = atts.getBGColor();
				
				blink(graph, cell, col.brighter(), col);
			}
			
			//** DATA **\\
			if (desc instanceof IDataDescriptor) {

				Object data = ((IDataDescriptor) desc).getData();

				if (data == null && cell != null) {

					JOptionPane.showMessageDialog(null, "La value est null !",
							"Alert", JOptionPane.ERROR_MESSAGE);
				}

				Object key = graph.getJlowmodel().getModelindex(desc);
				// Attributs atts =
				// graph.getRegister().getAtt(desc.getIDAtts());
				Attributs atts = graph.getJlowmodel().getAttributs(key);

				// Color for complet data
				Color col = null;
				Object tostring = null;
				
				if (data != null) {

					// Be able customize //TODO : setFlag
					// ((IDataDescriptor)
					// desc).setFlag(IDataDescriptor.NORECEIVE);
					// //Not receive again
/*
					tostring = Module.exec("tostring", desc, "toString",
							new Object[] {});
			*/
//					 Gets the module
					Module mod = (Module) ((IDescriptor) desc).getModule("tostring");
					
					// Sets the module with the specify descriptor
					/*if(mod!=null && mod instanceof ToStringModule) {
						mod.setDescriptor((IDescriptor)desc);
						tostring = ((ToStringModule) mod).toString();
					}*/
					
					col = (Color) atts.getAtt(Attributs.FILLDATACOLOR);
					if (col == null)
						col = Color.WHITE;
					// End
				} else {
					// Be able customize

					col = (Color) atts.getAtt(Attributs.ERRORDATACOLOR); // Color
					// error

					if (col == null)
						col = Attributs.DEFAULTEDC;

				}

				// Be able customize

				if (cell != null) {
					// Set the color
					graph.changeAtt((GraphCell) cell, Attributs.DRAWCOLOR, col);
					
					// Set the title
					if(tostring!=null) {
						UserObject userObj = (UserObject) ((DefaultGraphCell) cell).getUserObject();
						if(tostring!=null)
							userObj.setTitle(tostring.toString());
					}
				}
			}
		}
	}
	
	public void blink(Jlow g, GraphCell c, Color c1, Color c2) {
		final Jlow graph = g;
		final GraphCell cell = c;
		final Color color2 = c2;

		graph.changeAtt((GraphCell) cell, Attributs.BGCOLOR, c1);

		Thread tblink = new Thread() {

			public void run() {
				try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				graph.changeAtt((GraphCell) cell, Attributs.BGCOLOR, color2);
			}
		};
		tblink.start();
	}
}